/* 
 * Copyright (c) 2004  Clemson University.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "Array.h"
#include <stdio.h>  // FILE, fopen, ...

// -------------------- all includes must go before these lines ------------------
#if defined(DEBUG) && defined(WIN32) && !defined(NO_MFC)
#include <afxwin.h>
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
// -------------------- all code must go after these lines -----------------------

namespace blepo
{ 

void Save(const ArrFlt& src, const char* fname)
{
  FILE* fp = fopen(fname, "wt");
  for (int i=0 ; i<src.Len() ; i++) {
    float f = src[i];
    fprintf(fp, "%10.8f ", f);
  }
  fprintf(fp, "\n");
  fclose(fp);
}

};  // namespace blepo

